/* ccgo: go/gotest.cc
 *
 * Copyright 2003 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <textgo.hh>
#include <sstream>
#include <string>
extern "C" {
#include <readline/readline.h>
#include <readline/history.h>
}

using namespace std;

int main()
{
	text::Game w;
	bool cn = true;
	do {
		char * l = readline("=>");
		istringstream s(l);
		string c;
		s >> c;
		bool ok = true;
		if (c == "exit" || c == "") cn = false;
		else if (c == "init") {
			w.init();
		} else if (c == "move") {
			char d;
			int x;
			s >> d >> x;
			if (d > 'i') d --;
			int l = d - 'a';
			l = (19 - x) * 19 + l;
			w.add_move(l);
		} else if (c == "up") {
			w.up();
		} else if (c == "down") {
			int n = 0;
			if (! s.eof()) s >> n;
			w.down(n);
		} else {
			cout << "unknown command: " << c << endl;
			ok = false;
		}
		if (ok) {
			add_history(l);
			w.show(cout);
		}
		free(l);
	} while (cn);
}
