/* ccgo: sgf/node.cc
 * 
 * Copyright 2002,2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "node.hh"
#include "sgf.hh"
using namespace std;
using namespace sgf;

bool Node::load(istream & f)
{
	prop_list.clear();
	skip_white(f);
	if (f.eof() || f.peek() != ';') return false;
	f.get();
	Prop p;
	while (p.load(f)) prop_list.push_back(p);
	return true;
}

void Node::save(ostream & f) const
{
	f << ';';
	for (vector<Prop>::const_iterator i = prop_list.begin(); i != prop_list.end(); i ++) {
		i->save(f);
	}
	// f << endl;
}

const Prop * Node::find(const string & s) const
{
	for (vector<Prop>::const_iterator i = prop_list.begin(); i != prop_list.end(); i ++) {
		if (s == i->get_id()) return & (* i);
	}
	return NULL;
}
